Subject: Re: [BUG?] bonding, slave selection, carrier loss, etc.

From: Chris Friesen <[email-masked]>
Date: Mon, 13 Feb 2012 12:16:59 -0600

On 02/11/2012 12:52 PM, Ben Hutchings wrote:
> On Fri, 2012-02-10 at 17:53 -0800, Jay Vosburgh wrote:
>> Chris Friesen<[email-masked]>  wrote:

>>> The best solution would be for bonding to just register for notification
>>> of the link going down.  Presumably most drivers should be doing that
>>> properly by now, and for devices that get interrupt-driven notification
>>> of link status changes this would allow the bonding code to react much
>>> quicker.
>>
>> 	A quick look at some drivers shows that at least acenic still
>> doesn't do netif_carrier_off, so converting entirely to a notifier-based
>> failover mechanism would break drivers that work today.
> [...]
>
> It might be worth having some sort of feature flag (in priv_flags) that
> indicates whether the driver updates the link state.  Alternately,
> disable polling of a device once you see a notification.

This makes a lot of sense to me...it is suboptimal to still be polling 
when most people that care about bonding reliability are going to be 
using ethernet hardware with interrupt-based link change notification.

Chris

-- 
Chris Friesen
Software Developer
GENBAND
[email-masked]
www.genband.com